// tstBase.cpp : Implementation of CtstBase
#include "stdafx.h"
#include "Asp0205.h"
#include "tstBase.h"

/////////////////////////////////////////////////////////////////////////////
// CtstBase


STDMETHODIMP CtstBase::getTimeout(VARIANT *pvarScriptTimeout)
{
    HRESULT hr = S_OK;
    CComBSTR b("/LM/W3SVC/1/Root");
    CComBSTR c ("/chap2");
    METADATA_HANDLE hMetaData;
    METADATA_RECORD mdRecord;
    DWORD lnth;
    DWORD dwTime;
    CComPtr <IMSAdminBase> spAdminBase; 
    CComVariant vtResponse;

    // get a pointer to the IIS Admin Base Object
    hr = CoCreateInstance(CLSID_MSAdminBase, NULL, CLSCTX_ALL, 
            IID_IMSAdminBase, (void **) &spAdminBase);  

    if (FAILED(hr))
        return hr;

    // open the key for the Development Web Server
    hr = spAdminBase->OpenKey(
        METADATA_MASTER_ROOT_HANDLE,
        b,
        METADATA_PERMISSION_READ,
        60000,
        &hMetaData
        ); 

    if (FAILED(hr))
        return hr;

    // define the METABASE_RECORD values for AspScriptTimeout
    mdRecord.dwMDIdentifier = MD_ASP_SCRIPTTIMEOUT;
    mdRecord.dwMDUserType = ASP_MD_UT_APP;
    mdRecord.pbMDData = (PBYTE)&dwTime;
    mdRecord.dwMDDataLen = sizeof(dwTime);
    mdRecord.dwMDDataType = DWORD_METADATA;
    mdRecord.dwMDAttributes = METADATA_INHERIT;

    // get the property value
    hr = spAdminBase->GetData(hMetaData, c, &mdRecord, &lnth);

    if (FAILED(hr))
        return hr;

    // assign the property value to the component return variable
    vtResponse = (long)dwTime;
    vtResponse.Detach(pvarScriptTimeout);

    // close the metabase key
    spAdminBase->CloseKey(hMetaData);

    return S_OK;
}


STDMETHODIMP CtstBase::setTimeout(DWORD dwTimeout)
{
    HRESULT hr = S_OK;
    CComBSTR b("/LM/W3SVC/1/Root");
    CComBSTR c ("/chap2");
    METADATA_HANDLE hMetaData;
    METADATA_RECORD mdRecord;
    CComPtr <IMSAdminBase> spAdminBase; 
    CComVariant vtResponse;

    // get a pointer to the IIS Admin Base Object
    hr = CoCreateInstance(CLSID_MSAdminBase, NULL, CLSCTX_ALL, 
        IID_IMSAdminBase, (void **) &spAdminBase);  

    // open key - access IIsWebServer
    hr = spAdminBase->OpenKey(
        METADATA_MASTER_ROOT_HANDLE,
        b,
        METADATA_PERMISSION_WRITE,
        60000,
        &hMetaData
        ); 

    if (FAILED(hr))
        return hr;

    // set METADATA_RECORD values
    mdRecord.dwMDIdentifier = MD_ASP_SCRIPTTIMEOUT;
    mdRecord.dwMDUserType = ASP_MD_UT_APP;
    mdRecord.pbMDData = (PBYTE)&dwTimeout;
    mdRecord.dwMDDataLen = sizeof(dwTimeout);
    mdRecord.dwMDDataType = DWORD_METADATA;
    mdRecord.dwMDAttributes = METADATA_INHERIT;

    // set property
    hr = spAdminBase->SetData(hMetaData, c, &mdRecord);

    if (FAILED(hr)) 
        return hr;

    // close key before saving
    spAdminBase->CloseKey(hMetaData);

    // save change to metabase
    hr = spAdminBase->SaveData();

    return hr;
}
