// pooledComponent.cpp : Implementation of CpooledComponent
#include "stdafx.h"
#include "Asp0502.h"
#include "pooledComponent.h"

/////////////////////////////////////////////////////////////////////////////
// CpooledComponent
HRESULT CpooledComponent::Activate()
{
   HRESULT hr;
   CComBSTR bstrProp;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
	hr = CoGetObjectContext(IID_IObjectContext, 
                             (void **)&m_spObjectContext);
   if (FAILED(hr)) return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) return hr;

   // get Response property
   bstrProp = "Response";
   hr = pProps->GetProperty( bstrProp, &vt ) ;
   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

	return hr;
}  

void CpooledComponent::Deactivate()
{
   m_piResponse.Release();
	m_spObjectContext.Release();
}

BOOL CpooledComponent::CanBePooled()
{
	return TRUE;
} 



STDMETHODIMP CpooledComponent::testPooledComponent()
{

   // print message
   CComVariant vt("Hello from pooled component");
   m_piResponse->Write(vt);

	return S_OK;
}
