// pooledComponent.h : Declaration of the CpooledComponent

#ifndef __POOLEDCOMPONENT_H_
#define __POOLEDCOMPONENT_H_

#include "resource.h"       // main symbols
#include <comsvcs.h>
#include <asptlb.h>

/////////////////////////////////////////////////////////////////////////////
// CpooledComponent
class ATL_NO_VTABLE CpooledComponent : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CpooledComponent, &CLSID_pooledComponent>,
	public IObjectControl,
	public IDispatchImpl<IpooledComponent, &IID_IpooledComponent, &LIBID_ASP0502Lib>
{
public:
	CpooledComponent()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_POOLEDCOMPONENT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CpooledComponent)
	COM_INTERFACE_ENTRY(IpooledComponent)
    COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IpooledComponent
public:
	STDMETHOD(testPooledComponent)();
   	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

private:
    CComPtr<IObjectContext> m_spObjectContext;
    CComPtr<IResponse> m_piResponse;

};

#endif //__POOLEDCOMPONENT_H_
