// arry.cpp : Implementation of Carry
#include "stdafx.h"
#include "Asp0602.h"
#include "arry.h"


using namespace std;



// method to parse variant array and print out contents
STDMETHODIMP Carry::tstArray(VARIANT *pVariantArray)
{
    HRESULT hr = S_OK;
    LONG lLBound, lUBound;
    _variant_t vtVal;
	  
    CComVariant vtOut;
    CComPtr<IObjectContext> piObjectContext;
    CComPtr<IResponse> piResponse;          
    CComBSTR bstrObj;
    CComVariant vt;
    CComPtr<IGetContextProperties> pProps; //Context Properties

    IDispatch* piDispatch = NULL;

    // get context object
    hr = CoGetObjectContext(IID_IObjectContext,(void **)&piObjectContext);
    if (FAILED(hr))
      return hr;
   
    // get Context Properties
    hr = piObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
    if (FAILED(hr)) 
       return hr;

    // get ASP Response property
    bstrObj = "Response";
    hr = pProps->GetProperty( bstrObj, &vt ) ;
    if (FAILED(hr))
       return hr;

    piDispatch = vt.pdispVal;
    hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&piResponse );

	// wrap variant array with _variant_t for resource allocation and 
	// deallocation
	_variant_t vtArray (pVariantArray);

    // get variant type
	VARTYPE vttype = V_VT(&vtArray);

	// if ARRAY, process as SAFEARRAY
	if (vttype & VT_ARRAY)
	{

		SAFEARRAY * psa;
		_variant_t vtValue;

		// copy variant array to SAFEARRAY
		hr = SafeArrayCopy(*(vtArray.pparray), &psa);
		if (FAILED(hr)) {
			return hr;
		}

		// get dimensions of array
		// Get array bounds.
		hr = SafeArrayGetLBound(psa, 1, &lLBound);
		if (FAILED(hr))
          return hr;

		hr = SafeArrayGetUBound(psa, 1, &lUBound);
		if (FAILED(hr))
          return hr;

		// get each value, print out
        vtVal = "<p>";
		for (long l = lLBound; l <= lUBound; l++) {
			SafeArrayGetElement(psa, &l, &vtValue);

			// print out
			piResponse->Write(vtValue);
            piResponse->Write(vtVal);
			} 


		// cleanup
		SafeArrayDestroy(psa);

	}

	// else, if passed in as BSTR 
    //(JScript or other as concatenated string)
	else if (vttype & VT_BSTR) {

		
	   // output variant
	   _variant_t vtOut;
	 
		char cFind = ',';
		wstring::size_type iPos;
		wstring strFound;
		
		// pull out variant, convert to bstr	
		_bstr_t bstrMine (vtArray);


		// assign to STL wstring for manipulation
		wstring wstrVariant = bstrMine;

		// parse string
		iPos = wstrVariant.find(cFind,0);
      vtVal = "<p>";
		while (iPos != wstring::npos) {
			strFound = wstrVariant.substr(0,iPos);
			vtOut = strFound.c_str();
			piResponse->Write(vtOut);
            piResponse->Write(vtVal);
			wstrVariant = wstrVariant.substr(iPos + 1);
			iPos = wstrVariant.find(cFind,0);			
		}
		vtOut = wstrVariant.c_str();
		piResponse->Write(vtOut);
      piResponse->Write(vtVal);
	}
	else
		return E_INVALIDARG; 
		
	return S_OK;
}

STDMETHODIMP Carry::tstArray2(VARIANT *pVariantArray)
{
	HRESULT hr;
    SAFEARRAY * psaiNew; 
    SAFEARRAYBOUND aDim[1]; 
    aDim[0].lLbound = 0; 
    aDim[0].cElements = 4; 
    long l;
     _variant_t v;

     // Equivalent to: Dim aiNew(1 To 8) As Integer.
    psaiNew = SafeArrayCreate(VT_VARIANT, 1, aDim);
    if (psaiNew != NULL) {
        l = 0;
        v = "one";
        SafeArrayPutElement(psaiNew, &l, &v);
        l = 1;
        v = "two";
        SafeArrayPutElement(psaiNew, &l, &v);
        l = 2;
        v = "three";
        SafeArrayPutElement(psaiNew, &l, &v);
        l = 3;
        v = "four";
        hr = SafeArrayPutElement(psaiNew, &l, &v);
        if (FAILED(hr))
           return hr;
    }
    V_VT(pVariantArray) = VT_ARRAY | VT_VARIANT;
    V_ARRAY(pVariantArray) = psaiNew;
        
	return S_OK;
}
