// JustInTime.h : Declaration of the CJustInTime

#ifndef __JUSTINTIME_H_
#define __JUSTINTIME_H_

#include "resource.h"       // main symbols
#include <comsvcs.h>
#include <asptlb.h>
#include <comdef.h>

/////////////////////////////////////////////////////////////////////////////
// CJustInTime
class ATL_NO_VTABLE CJustInTime : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CJustInTime, &CLSID_JustInTime>,
    public IObjectControl,
	public IDispatchImpl<IJustInTime, &IID_IJustInTime, &LIBID_ASP1401Lib>
{
public:
	CJustInTime()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_JUSTINTIME)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CJustInTime)
	COM_INTERFACE_ENTRY(IJustInTime)
    COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IJustInTime
public:
	STDMETHOD(encodeValues)(/*[in]*/ BSTR bstrHTML, BSTR bstrURL, BSTR bstrPath, BSTR bstrMap);
	STDMETHOD(showVariables)();
	STDMETHOD(listContents)();
	STDMETHOD(getContentValue)(/*[in]*/ BSTR bstrName);
	STDMETHOD(setCacheDate)(/*[in]*/ int iYear, int iMonth, int iDay);
	STDMETHOD(sayHello)(/*[in]*/ BSTR bstrName);
   STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

private:
   CComPtr<IObjectContext> m_spObjectContext;
   CComPtr<IResponse> m_piResponse;
   CComPtr<IApplicationObject> m_piApplication;
   CComPtr<ISessionObject> m_piSession;
   CComPtr<IRequest> m_piRequest;
   CComPtr<IServer> m_piServer;

};

#endif //__JUSTINTIME_H_
