// MtsObject.h : Declaration of the CMtsObject

#ifndef __MTSOBJECT_H_
#define __MTSOBJECT_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CMtsObject
class ATL_NO_VTABLE CMtsObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMtsObject, &CLSID_MtsObject>,
	public IObjectControl,
	public IDispatchImpl<IMtsObject, &IID_IMtsObject, &LIBID_ASP1402Lib>
{
public:
	CMtsObject()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MTSOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

DECLARE_NOT_AGGREGATABLE(CMtsObject)

BEGIN_COM_MAP(CMtsObject)
	COM_INTERFACE_ENTRY(IMtsObject)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// IMtsObject
public:
	STDMETHOD(addNumbers)(/*[in]*/ int iFirst, int iSecond, /*[out,retval]*/ int* iResult);
};

#endif //__MTSOBJECT_H_
