// message.cpp : Implementation of Cmessage
#include "stdafx.h"
#include "Asp1601.h"
#include "message.h"

#import <msado15.dll> rename ( "EOF", "adoEOF" ) no_namespace
#import <cdosys.dll> no_namespace


/////////////////////////////////////////////////////////////////////////////
// Cmessage


STDMETHODIMP Cmessage::sendMessage(BSTR bstrTo, BSTR bstrFrom, 
                                   BSTR bstrSubject, BSTR bstrMessage)
{
    HRESULT hr;
    IMessagePtr   iMsg(__uuidof(Message));
    IConfigurationPtr iConf(__uuidof(Configuration));
    FieldsPtr         Flds;

    // set configuration fields
    Flds = iConf->Fields;

    // set configuration properties
    Flds->Item[cdoSendUsingMethod]->Value = 
          _variant_t((long)cdoSendUsingPort);

    Flds->Item[cdoSMTPServer]->Value  = 
          _variant_t("mail.company.com");

    Flds->Item[cdoSMTPConnectionTimeout]->Value = _variant_t((long)20);
    Flds->Item[cdoSMTPAuthenticate]->Value      = _variant_t((long)cdoBasic);
    Flds->Item[cdoSendUserName]->Value          = _variant_t("userid");
    Flds->Item[cdoSendPassword]->Value          = _variant_t("somepassword");

    Flds->Item[cdoURLGetLatestVersion]->Value   = 
          _variant_t(VARIANT_TRUE);

    // update fields
    Flds->Update();

    // attach config properties to message
    iMsg->Configuration = iConf;
    iMsg->To        = bstrTo;
    iMsg->From      = bstrFrom;
    iMsg->Subject   = bstrSubject;
    iMsg->TextBody  = bstrMessage;


    // send message
    hr=iMsg->Send();
    
   return hr;
}

STDMETHODIMP Cmessage::sendMultiPart(BSTR bstrTo, BSTR bstrFrom, BSTR bstrSubject, BSTR bstrMessage)
{
    HRESULT hr;
    IMessagePtr   iMsg(__uuidof(Message));
    IConfigurationPtr iConf(__uuidof(Configuration));
    FieldsPtr         Flds;

    // set configuration fields
    Flds = iConf->Fields;

    // set configuration properties
    Flds->Item[cdoSendUsingMethod]->Value = 
          _variant_t((long)cdoSendUsingPort);

    Flds->Item[cdoSMTPServer]->Value  = 
          _variant_t("mail.company.com");

    Flds->Item[cdoSMTPConnectionTimeout]->Value = _variant_t((long)20);
    Flds->Item[cdoSMTPAuthenticate]->Value      = _variant_t((long)cdoBasic);
    Flds->Item[cdoSendUserName]->Value          = _variant_t("userid");
    Flds->Item[cdoSendPassword]->Value          = _variant_t("somepassword");

    Flds->Item[cdoURLGetLatestVersion]->Value   = 
          _variant_t(VARIANT_TRUE);

    // update fields
    Flds->Update();

    // attach config properties to message
    iMsg->Configuration = iConf;
    iMsg->To        = bstrTo;
    iMsg->From      = bstrFrom;
    iMsg->Subject   = bstrSubject;  

    // HTML and plain text
    iMsg->AutoGenerateTextBody = true;
    iMsg->HTMLBody = bstrMessage;

    // send message
    hr=iMsg->Send();
    
   return hr;
}

STDMETHODIMP Cmessage::sendMixedMultiPart(BSTR bstrTo, BSTR bstrFrom, 
                                          BSTR bstrSubject, BSTR bstrMessage, 
                                          BSTR bstrHTMLMsg, BSTR bstrGIF)
{
    HRESULT hr;
    IMessagePtr   iMsg(__uuidof(Message));
    IConfigurationPtr iConf(__uuidof(Configuration));
    FieldsPtr         Flds;

    // set configuration fields
    Flds = iConf->Fields;

    // set configuration properties
    Flds->Item[cdoSendUsingMethod]->Value = 
          _variant_t((long)cdoSendUsingPort);

    Flds->Item[cdoSMTPServer]->Value  = 
          _variant_t("mail.company.com");

    Flds->Item[cdoSMTPConnectionTimeout]->Value = _variant_t((long)20);
    Flds->Item[cdoSMTPAuthenticate]->Value      = _variant_t((long)cdoBasic);
    Flds->Item[cdoSendUserName]->Value          = _variant_t("userid");
    Flds->Item[cdoSendPassword]->Value          = _variant_t("somepassword");

    Flds->Item[cdoURLGetLatestVersion]->Value   = 
          _variant_t(VARIANT_TRUE);

    // update fields
    Flds->Update();

    // attach config properties to message
    iMsg->Configuration = iConf;
    iMsg->To        = bstrTo;
    iMsg->From      = bstrFrom;
    iMsg->Subject   = bstrSubject;


    // **** multi-part **** //
    IBodyPartPtr iBPMain;
    IBodyPartPtr iBPText;
    IBodyPartPtr iBPHTML;
    IBodyPartPtr iBPGif;
    _StreamPtr iStm;

    iBPMain = iMsg->BodyPart;
    iBPMain->put_ContentMediaType(cdoMultipartMixed);

    // text
    // properties set directly
    iBPText = iBPMain->AddBodyPart(-1);
    iBPText->put_ContentMediaType(cdoTextPlain);
    iBPText->put_ContentTransferEncoding(cdo8bit);

    // message body
    iStm = iBPText->GetDecodedContentStream();
    iStm->WriteText(bstrMessage,adWriteChar);
    hr=iStm->Flush();

    if (FAILED(hr)) return hr;


    // html
    // properties set using Fields
    iBPHTML = iBPMain->AddBodyPart(-1);
    Flds = iBPHTML->GetFields();
    Flds->Item[cdoContentType]->Value = cdoTextHTML;
    Flds->Item[cdoContentTransferEncoding]->Value = cdoQuotedPrintable;
    Flds->Update();

    // message body
    iStm = iBPHTML->GetDecodedContentStream();
    iStm->WriteText(bstrHTMLMsg,adWriteChar);
    hr=iStm->Flush();

    if (FAILED(hr)) return hr;


    // image
    // properties set directly
    iBPGif = iBPMain->AddBodyPart(-1);
    iBPGif->put_ContentMediaType(cdoGif);
    iBPGif->put_ContentTransferEncoding(cdoBase64);

    // message body, GIF loaded from file
    iStm = iBPGif->GetDecodedContentStream();
    iStm->LoadFromFile(bstrGIF);
    hr=iStm->Flush();

    if (FAILED(hr)) return hr;

    // send message
    hr=iMsg->Send();
    
   return hr;
}

STDMETHODIMP Cmessage::sendAttachments(BSTR bstrTo, BSTR bstrFrom, 
                                       BSTR bstrSubject, BSTR bstrMessage, 
                                       BSTR bstrAttachment1, BSTR bstrFile, 
                                       BSTR bstrAttachment2)
{
    HRESULT hr;
    IMessagePtr   iMsg(__uuidof(Message));
    IConfigurationPtr iConf(__uuidof(Configuration));
    FieldsPtr         Flds;

    // set configuration fields
    Flds = iConf->Fields;

    // set configuration properties
    Flds->Item[cdoSendUsingMethod]->Value = 
          _variant_t((long)cdoSendUsingPort);

    Flds->Item[cdoSMTPServer]->Value  = 
          _variant_t("mail.company.com");

    Flds->Item[cdoSMTPConnectionTimeout]->Value = _variant_t((long)20);
    Flds->Item[cdoSMTPAuthenticate]->Value      = _variant_t((long)cdoBasic);
    Flds->Item[cdoSendUserName]->Value          = _variant_t("someuser");
    Flds->Item[cdoSendPassword]->Value          = _variant_t("somepassword");

    Flds->Item[cdoURLGetLatestVersion]->Value   = 
          _variant_t(VARIANT_TRUE);

    // update fields
    Flds->Update();

    // attach config properties to message
    iMsg->Configuration = iConf;
    iMsg->To        = bstrTo;
    iMsg->From      = bstrFrom;
    iMsg->Subject   = bstrSubject;
    iMsg->TextBody  = bstrMessage;

    // **** attachment **** //
    IBodyPartPtr iBPMain;
    IBodyPartPtr iBPAttach;
    _StreamPtr iStm;

    // Attachment 1
    iBPMain = iMsg->AddAttachment(bstrAttachment1,"","");

    // Attachment 2, from file
    iBPAttach = iBPMain->AddBodyPart(-1);
    iBPAttach->put_ContentMediaType(cdoGif);
    iBPAttach->put_ContentTransferEncoding(cdoBase64);

    Flds = iBPAttach->GetFields();
    Flds->Item[cdoContentDisposition]->Value = 
      _bstr_t("attachment; filename=\"") + _bstr_t(bstrFile) + _bstr_t("\"");
    Flds->Update();

    // message body
    iStm = iBPAttach->GetDecodedContentStream();
    iStm->LoadFromFile(bstrAttachment2);
    hr=iStm->Flush();

    if (FAILED(hr)) return hr;

    // send message
    hr=iMsg->Send();
    
   return hr;
}
