// drop.cpp : Implementation of Cdrop
#include "stdafx.h"
#include "Asp1602.h"
#include "drop.h"

#import <msado15.dll> rename ( "EOF", "adoEOF" ) no_namespace
#import <cdosys.dll> no_namespace

HRESULT Cdrop::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
	hr = CoGetObjectContext(IID_IObjectContext, (void **)&m_spObjectContext);
   if (FAILED(hr))
      return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   return hr;
} 

BOOL Cdrop::CanBePooled()
{
	return TRUE;
} 

void Cdrop::Deactivate()
{
    m_piResponse.Release();
	m_spObjectContext.Release();
} 

/////////////////////////////////////////////////////////////////////////////
// Cdrop


STDMETHODIMP Cdrop::getMessages()
{
  IDropDirectoryPtr   iDDirectory(__uuidof(DropDirectory));
  IMessagesPtr iMessages;

  try {

    // get messages from drop directory
    iMessages = iDDirectory->GetMessages(L"c:\\inetpub\\mailroot\\drop");

    long lCt;
    lCt = iMessages->Count;

    // setup output table
    m_piResponse->Write (_variant_t("<table border=2 width='80%' align='center' cellpadding=10"));
    m_piResponse->Write (_variant_t("<TR><TH>From</TH><TH>Subject</TH></TR>"));

    
    // process each message
    for (long l = 1; l <=lCt; l++) {
        IMessagePtr pMsg;
        iMessages->get_Item(l,&pMsg);

        // process message info
        m_piResponse->Write(_variant_t("<TR><TD>"));
        m_piResponse->Write(_variant_t("<a href='asp1606.asp?ct="));
        m_piResponse->Write(_variant_t(l));
        m_piResponse->Write(_variant_t("'>"));
        m_piResponse->Write(_variant_t(pMsg->From + "</a></td><td>"));
        m_piResponse->Write(_variant_t(pMsg->Subject + "</td></tr>")); 
    }

    m_piResponse->Write(_variant_t("</table>"));

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }
  return S_OK;
}

STDMETHODIMP Cdrop::getMessage(long lItem)
{
  IDropDirectoryPtr   iDDirectory(__uuidof(DropDirectory));
  IMessagesPtr iMessages;
  IMessagePtr pMsg;

  try {
    // get messages from drop directory
    iMessages = iDDirectory->GetMessages(L"c:\\inetpub\\mailroot\\drop");

    // get message
    iMessages->get_Item(lItem,&pMsg);

    // process message info
    m_piResponse->Write(_variant_t("<P>From: " + pMsg->From));
    m_piResponse->Write(_variant_t("<P>Subject: " + pMsg->Subject));
    m_piResponse->Write(_variant_t("<p>" + pMsg->TextBody));

    // delete message
    iMessages->Delete(lItem);

  }
  catch (_com_error e) {
      m_piResponse->Write(_variant_t(e.Description()));
  }

  return S_OK;
}
