VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "group"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' create a group in the Users container
Sub createGroup(ByVal strGrpName As String)

On Error GoTo ErrorHandler

   ' container and group objects
   Dim iObj As IADsContainer
   Dim iGrp As IADsGroup
   Dim strRNname As String
   
   ' change group name to relative group name
   strRNname = "CN=" & strGrpName

   ' obtain reference to Users
   ' create new group
   Set iObj = GetObject("LDAP://CN=Users,DC=development,DC=local")
   Set iGrp = iObj.Create("group", strRNname)

   ' required properties
   iGrp.Put "cn", strGrpName
   iGrp.Put "groupType", _
            ADS_GROUP_TYPE_GLOBAL_GROUP Or ADS_GROUP_TYPE_SECURITY_ENABLED
   iGrp.Put "sAMAccountName", strGrpName

   ' save change back to Directory service
   iGrp.SetInfo

Exit Sub
ErrorHandler:
  
   Err.Raise Err.Number, Err.Source, Err.Description
   
End Sub

' remove group
Sub removeGroup(ByVal strGrpName As String)

On Error GoTo ErrorHandler

   ' get container
   Dim iGrpObj As IADsContainer
   Set iGrpObj = GetObject("LDAP://CN=Users,DC=development,DC=local")

   Dim strRNname As String
   
   ' change group name to relative group name
   strRNname = "CN=" & strGrpName

   ' delete group
   iGrpObj.Delete "group", strRNname

Exit Sub
ErrorHandler:

   Err.Raise Err.Number, Err.Source, Err.Description

End Sub



' show users for given group
Function getUsers(ByVal strGrpName As String) As Variant

On Error GoTo ErrorHandler
   
   ' create group
   Dim iGrp As IADsGroup
   Dim strGroup As String

   ' create ADsPaths for group and user
   strGroup = "LDAP://CN=" & strGrpName & ",CN=Users,DC=development,DC=local"

   Set iGrp = GetObject(strGroup)
   Dim varArray() As Variant
   ReDim varArray(iGrp.Members.Count)
   
   Dim oMember As IADs
   Dim i As Integer
   i = 0
   For Each oMember In iGrp.Members
       varArray(i) = oMember.Get("cn")
       i = i + 1
    Next
   
   getUsers = varArray
Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Getting Users: " & Err.Description

End Function

' show all groups
Function getGroups() As Recordset

On Error GoTo ErrorHandler

   ' connect to Active Directory
   Dim cn As New Connection
   cn.CursorLocation = adUseClient
   cn.Provider = "ADsDSOObject"
   cn.Open
      
   ' set recordset
   Dim rs As New Recordset
   Set rs.ActiveConnection = cn
   
   ' perform query
   Dim str As String
   str = "select cn, distinguishedName " & _
      "from 'LDAP://DC=development, DC=local' where " & _
      "objectCategory = 'group'"
      
   rs.Source = str
   rs.Open
   
   ' disconnect recordset
   Set rs.ActiveConnection = Nothing
   cn.Close
   
   ' return record
   Set getGroups = rs
   
Exit Function
ErrorHandler:

   cn.Close
   Err.Raise Err.Number, Err.Source, Err.Description

End Function

' add user to a group
Sub addUserToGroup(ByVal strGrpName As String, _
             ByVal strUserName As String)

On Error GoTo ErrorHandler

   ' create group
   Dim iGrp As IADsGroup
   Dim strGroup, strUser As String

   ' create ADsPaths for user
   strUser = "LDAP://CN=" & strUserName & ",CN=Users,DC=development,DC=local"

   ' create ADsPath for group, given distinguishedName
   strGroup = "LDAP://" & strGrpName
      
   ' get group object
   Set iGrp = GetObject(strGroup)

   ' add user to group
   iGrp.Add (strUser)

Exit Sub
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Adding User to Group " & Err.Description
End Sub


Sub removeUserFromGroup(ByVal strGrpName As String, _
                         ByVal strUserName As String)
                         
On Error GoTo ErrorHandler

   ' create group
   Dim iGrp As IADsGroup
   Dim strGroup, strUser As String

   ' create ADsPaths for user
   strUser = "LDAP://CN=" & strUserName & ",CN=Users,DC=development,DC=local"

   ' create ADsPath for group, given distinguishedName
   strGroup = "LDAP://" & strGrpName
      
   ' get group object
   Set iGrp = GetObject(strGroup)

   ' add user to group
   iGrp.Remove (strUser)

Exit Sub
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Adding User to Group " & Err.Description
                         
End Sub

