VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "mediaobj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data wrapper that updates and queries MediaObject table
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Wrapper methods


' create media obj
Sub createMediaObj(ByVal strName As String, ByVal strFile As String, _
                     ByVal strExt As String, ByVal varSize As Variant, _
                     ByVal strCode As String, ByVal varDirectoryId As Variant, _
                     ByVal varWidth As Variant, ByVal varHeight As Variant, _
                     ByVal varOptToolId As Variant, ByVal varOptDate As Variant, _
                     ByVal varPulledDt As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' possible null values
If Len(varWidth) = 0 Then
   varWidth = "null"
End If
If Len(varHeight) = 0 Then
   varHeight = "null"
End If
If Len(varOptToolId) = 0 Then
   varOptToolId = "null"
End If
If Len(varOptDate) = 0 Then
   varOptDate = "null"
Else
   varOptDate = "'" & varOptDate & "'"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)

' build insert
Dim str As String
str = "insert into MediaObject (name, filename, ext, file_size, " & _
           "container_width, container_height, media_type_cd, directory_id, " & _
           "optimized_tool_id, optimized_date, pulled_date)" & _
           " values('" & strName & "','" & strFile & "','" & UCase(strExt) & _
           "'," & varSize & "," & varWidth & "," & varHeight & ",'" & _
           strCode & "'," & varDirectoryId & "," & varOptToolId & "," & _
           varOptDate & "," & varPulledDt & ")"
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Creating Media Object: " & Err.Description

End Sub



' update media object
Sub updateMediaObj(ByVal varMediaId As Variant, _
                     ByVal strName As String, ByVal strFile As String, _
                     ByVal strExt As String, ByVal varSize As Variant, _
                     ByVal strCode As String, ByVal varDirectoryId As Variant, _
                     ByVal varWidth As Variant, ByVal varHeight As Variant, _
                     ByVal varOptToolId As Variant, ByVal varOptDate As Variant, _
                     ByVal varPulledDt As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

' possible null value for purpose
' possible null values
If Len(varWidth) = 0 Then
   varWidth = "null"
End If
If Len(varHeight) = 0 Then
   varHeight = "null"
End If
If Len(varOptToolId) = 0 Then
   varOptToolId = "null"
End If
If Len(varOptDate) = 0 Then
   varOptDate = "null"
Else
   varOptDate = "'" & varOptDate & "'"
End If
If Len(varPulledDt) = 0 Then
   varPulledDt = "null"
Else
   varPulledDt = "'" & varPulledDt & "'"
End If


' truncate strings if necessary
strName = UCase(Left(strName, 20))
strFile = Left(strFile, 20)

' create command
Dim comnd As New Command
Set comnd.ActiveConnection = cn
comnd.CommandType = adCmdText

' build update
Dim str As String
str = "update MediaObject set " _
      & "name = '" & strName & "', " _
      & "filename = '" & strFile & "', " _
      & "ext = '" & UCase(strExt) & "', " _
      & "file_size = " & varSize & ", " _
      & "container_width = " & varWidth & ", " _
      & "container_height = " & varHeight & ", " _
      & "media_type_cd = '" & strCode & "', " _
      & "directory_id = " & varDirectoryId & ", " _
      & "optimized_tool_id = " & varOptToolId & ", " _
      & "optimized_date = " & varOptDate & ", " _
      & "pulled_date = " & varPulledDt _
      & " where id = " & CStr(varMediaId)
      
comnd.CommandText = str

comnd.Execute

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Updating Directory: " & Err.Description

End Sub




' delete specific media obj
Sub deleteMediaObject(ByVal varMediaId As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' build deletion
Dim str As String
str = "delete from MediaObject where id = " & CStr(varMediaId)
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Media Object: " & Err.Description

End Sub

' return all media objects by media type
Function getMediaObjectsByType(ByVal strTypeCode As String) As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

' query for directories
Dim str As String
str = "select * from MediaObject where media_type_cd = '" & strTypeCode & "' " & _
      "order by name"
rs.Open str, cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getMediaObjectsByType = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Media Objects: " & Err.Description

End Function


' return partial records for all media objects
Function getPartialMediaObjects() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

rs.CursorLocation = adUseClient

' query for directories
Dim str As String
str = "select a.id, a.name, filename, media_type_cd, b.name " & _
      "from MediaObject a, Directory b where directory_id = b.id " & _
      " order by 4, 2"
rs.Open str, cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getPartialMediaObjects = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Partial MediaObjects: " & Err.Description

End Function


' return specific item
Function getMediaObject(ByVal varMediaId As Variant) As ADODB.Recordset

Dim cn As New Connection
Dim rs As New Recordset
Dim errstr As String

On Error GoTo ErrorHandler

' open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' query for media objects
 Set rs.ActiveConnection = cn

' run query
Dim str As String
rs.Source = "select * from MediaObject where id = " & CStr(varMediaId)
rs.Open

' disconnect recordset
Set rs.ActiveConnection = Nothing
cn.Close

Set getMediaObject = rs
Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, errstr & "Retrieving MediaObject: " & Err.Description

End Function


