VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "tool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Directory
'
' Author: Shelley Powers
'
' Data wrapper that updates and queries Dictionary table
'=============================================================================

Implements ObjectControl

' Connection String
Private m_connString

' ObjectControl Methods
Private Sub ObjectControl_Activate()

' using OLE DB to access SQL Server version of database
'm_connString = "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' using ODBC to access Access 2000 database
m_connString = "DSN=weaver;uid=sa;pwd="

End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
 ' no activity
End Sub

'
'================================================================================
' Wrapper methods


' create directory
Sub createTool(ByVal strName As String, ByVal strLoc As String)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' truncate strings if necessary
strName = UCase(Left(strName, 20))
strLoc = Left(strLoc, 50)

' build insert
Dim str As String
str = "insert into AssistingTool (name, location)" & _
           " values('" & strName & "','" & strLoc & "')"
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Creating Tool: " & Err.Description

End Sub



' create directory
Sub updateTool(ByVal iToolId As Variant, _
                     ByVal strName As String, ByVal strLoc As String)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString
cn.Open

' create command
Dim comnd As New Command
Set comnd.ActiveConnection = cn
comnd.CommandType = adCmdText

' truncate strings if necessary
strName = UCase(Left(strName, 50))
strLoc = Left(strLoc, 50)
strPurpose = Left(strPurpose, 50)

' build update
Dim str As String
str = "update AssistingTool set " _
      & "name = '" & strName & "', " _
      & "location = '" & strLoc & "' " _
      & "where id = " & CStr(iToolId)
      
comnd.CommandText = str

comnd.Execute

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, str & "Updating Tool: " & Err.Description

End Sub




' delete specific directory
Sub deleteTool(ByVal iToolId As Variant)
                     
Dim objCntxt As ObjectContext

On Error GoTo ErrorHandler

Set objCntxt = GetObjectContext()
                     
' open connection
Dim cn As New Connection
cn.ConnectionString = m_connString

cn.Open

' build deletion
Dim str As String
str = "delete from AssistingTool where id = " & CStr(iToolId)
      
' execute sql
cn.Execute str

cn.Close

' commit and deactivate object
objCntxt.SetComplete

Exit Sub

ErrorHandler:

   ' abort and raise error and deactivate object
   objCntxt.SetAbort
   Err.Raise Err.Number, Err.Source, "Deleting Directory: " & Err.Description

End Sub

' return all directories
Function getTools() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

' query for directories
rs.Open "select * from AssistingTool order by name", _
        cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getTools = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Tools: " & Err.Description

End Function


' return all directories
Function getPartialTools() As ADODB.Recordset

' open connection
Dim cn As New Connection
Dim rs As New Recordset

On Error GoTo ErrorHandler

cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Mode = adModeRead
cn.Open

' query for tools
rs.Open "select id, name from AssistingTools order by name", _
        cn, adOpenForwardOnly, adLockReadOnly

Set rs.ActiveConnection = Nothing
cn.Close

Set getPartialTools = rs

Exit Function
ErrorHandler:

   Err.Raise Err.Number, Err.Source, "Retrieving Partial Tools: " & Err.Description

End Function


' return specific Directory item
Function getTool(ByVal iToolId As Variant) As ADODB.Recordset

Dim cn As New Connection
Dim rs As New Recordset
Dim errstr As String

On Error GoTo ErrorHandler

' open connection
cn.ConnectionString = m_connString
cn.CursorLocation = adUseClient
cn.Open

' query for directories
 Set rs.ActiveConnection = cn

' run query
Dim str As String
rs.Source = "select * from AssistingTool where id = " & CStr(iToolId)
rs.Open

' disconnect recordset
Set rs.ActiveConnection = Nothing
cn.Close

Set getTool = rs
Exit Function

ErrorHandler:

   Err.Raise Err.Number, Err.Source, errstr & "Retrieving Tool: " & Err.Description

End Function


